# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ExpandedTypedUserUser(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'username': 'str',
        'first_name': 'str',
        'last_name': 'str',
        'domain': 'str',
        'idp_id': 'str',
        'accessible': 'bool',
        'acct': 'str',
        'email': 'str',
        'user_id': 'str',
        'user_profile': 'BaseUserWithProfileUserProfile'
    }

    attribute_map = {
        'username': 'username',
        'first_name': 'firstName',
        'last_name': 'lastName',
        'domain': 'domain',
        'idp_id': 'idpId',
        'accessible': 'accessible',
        'acct': 'acct',
        'email': 'email',
        'user_id': 'userId',
        'user_profile': 'userProfile'
    }

    def __init__(self, username=None, first_name=None, last_name=None, domain=None, idp_id=None, accessible=None, acct=None, email=None, user_id=None, user_profile=None):  # noqa: E501
        """ExpandedTypedUserUser - a model defined in Swagger"""  # noqa: E501
        self._username = None
        self._first_name = None
        self._last_name = None
        self._domain = None
        self._idp_id = None
        self._accessible = None
        self._acct = None
        self._email = None
        self._user_id = None
        self._user_profile = None
        self.discriminator = None
        if username is not None:
            self.username = username
        if first_name is not None:
            self.first_name = first_name
        if last_name is not None:
            self.last_name = last_name
        if domain is not None:
            self.domain = domain
        if idp_id is not None:
            self.idp_id = idp_id
        if accessible is not None:
            self.accessible = accessible
        if acct is not None:
            self.acct = acct
        if email is not None:
            self.email = email
        if user_id is not None:
            self.user_id = user_id
        if user_profile is not None:
            self.user_profile = user_profile

    @property
    def username(self):
        """Gets the username of this ExpandedTypedUserUser.  # noqa: E501


        :return: The username of this ExpandedTypedUserUser.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this ExpandedTypedUserUser.


        :param username: The username of this ExpandedTypedUserUser.  # noqa: E501
        :type: str
        """

        self._username = username

    @property
    def first_name(self):
        """Gets the first_name of this ExpandedTypedUserUser.  # noqa: E501


        :return: The first_name of this ExpandedTypedUserUser.  # noqa: E501
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this ExpandedTypedUserUser.


        :param first_name: The first_name of this ExpandedTypedUserUser.  # noqa: E501
        :type: str
        """

        self._first_name = first_name

    @property
    def last_name(self):
        """Gets the last_name of this ExpandedTypedUserUser.  # noqa: E501


        :return: The last_name of this ExpandedTypedUserUser.  # noqa: E501
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this ExpandedTypedUserUser.


        :param last_name: The last_name of this ExpandedTypedUserUser.  # noqa: E501
        :type: str
        """

        self._last_name = last_name

    @property
    def domain(self):
        """Gets the domain of this ExpandedTypedUserUser.  # noqa: E501


        :return: The domain of this ExpandedTypedUserUser.  # noqa: E501
        :rtype: str
        """
        return self._domain

    @domain.setter
    def domain(self, domain):
        """Sets the domain of this ExpandedTypedUserUser.


        :param domain: The domain of this ExpandedTypedUserUser.  # noqa: E501
        :type: str
        """

        self._domain = domain

    @property
    def idp_id(self):
        """Gets the idp_id of this ExpandedTypedUserUser.  # noqa: E501


        :return: The idp_id of this ExpandedTypedUserUser.  # noqa: E501
        :rtype: str
        """
        return self._idp_id

    @idp_id.setter
    def idp_id(self, idp_id):
        """Sets the idp_id of this ExpandedTypedUserUser.


        :param idp_id: The idp_id of this ExpandedTypedUserUser.  # noqa: E501
        :type: str
        """

        self._idp_id = idp_id

    @property
    def accessible(self):
        """Gets the accessible of this ExpandedTypedUserUser.  # noqa: E501


        :return: The accessible of this ExpandedTypedUserUser.  # noqa: E501
        :rtype: bool
        """
        return self._accessible

    @accessible.setter
    def accessible(self, accessible):
        """Sets the accessible of this ExpandedTypedUserUser.


        :param accessible: The accessible of this ExpandedTypedUserUser.  # noqa: E501
        :type: bool
        """

        self._accessible = accessible

    @property
    def acct(self):
        """Gets the acct of this ExpandedTypedUserUser.  # noqa: E501


        :return: The acct of this ExpandedTypedUserUser.  # noqa: E501
        :rtype: str
        """
        return self._acct

    @acct.setter
    def acct(self, acct):
        """Sets the acct of this ExpandedTypedUserUser.


        :param acct: The acct of this ExpandedTypedUserUser.  # noqa: E501
        :type: str
        """

        self._acct = acct

    @property
    def email(self):
        """Gets the email of this ExpandedTypedUserUser.  # noqa: E501


        :return: The email of this ExpandedTypedUserUser.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this ExpandedTypedUserUser.


        :param email: The email of this ExpandedTypedUserUser.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def user_id(self):
        """Gets the user_id of this ExpandedTypedUserUser.  # noqa: E501


        :return: The user_id of this ExpandedTypedUserUser.  # noqa: E501
        :rtype: str
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """Sets the user_id of this ExpandedTypedUserUser.


        :param user_id: The user_id of this ExpandedTypedUserUser.  # noqa: E501
        :type: str
        """

        self._user_id = user_id

    @property
    def user_profile(self):
        """Gets the user_profile of this ExpandedTypedUserUser.  # noqa: E501


        :return: The user_profile of this ExpandedTypedUserUser.  # noqa: E501
        :rtype: BaseUserWithProfileUserProfile
        """
        return self._user_profile

    @user_profile.setter
    def user_profile(self, user_profile):
        """Sets the user_profile of this ExpandedTypedUserUser.


        :param user_profile: The user_profile of this ExpandedTypedUserUser.  # noqa: E501
        :type: BaseUserWithProfileUserProfile
        """

        self._user_profile = user_profile

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ExpandedTypedUserUser, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExpandedTypedUserUser):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
